#ifndef SolStack_h
#define SolStack_h

#include "OrdInt.h"
#include "RArray.h"

class SolStack {
public:
  SolStack();
  ~SolStack();
  void clear();
  void push(int );
  int empty();
  int pop();
  int top();
  OrdInt to_OrdInt();
  void from_OrdInt(OrdInt oi);
private:
  RArray<int> solution;
  int _top;
  int size;
};

inline void SolStack::push(int i) 
{ 
  if (size <= _top)
    {
      size *= 2;
      solution.ensure(size); 
    }
  solution[++_top] = i; 
}

#endif
