#ifndef _PBCScut_h
#define _PBCScut_h

// cover generation stuff
// make sure, that no literals can be fixed by fixing!
int GenerateCover(OrdInt& cover);
int GenerateMinimizedCover(OrdInt& cover);
int GenerateMinimizedCoverIneq(LPBIneq& lpbi);

// returns Enum.UNSAT if constraint set is unsatisfiable
//         Enum.SAT   if a solution was found
//         Enum.OPEN  if neither holds
int addcover(int& clen); // applies fixing if neccesary (clen = length of cover)

// if some cut stuff happens to find a solution; here you can get it
OrdInt get_last_solution(); 

// options for cutgeneration
int max_cut_nodes;
int set_max_cut_nodes(int m) { return max_cut_nodes = m; }
int get_max_cut_nodes() { return max_cut_nodes; }
int set_dellitheu(int h) { return Enum.select_to_del_lit_option = h; }
int get_dellitheu() { return Enum.select_to_del_lit_option; }

// statistics
int no_covers;
inline int get_no_covers() { return no_covers; }

inline int reset_cover_statistics()
{
  no_covers = 0;
  return 0;
}

#endif
