#ifndef _PBCSequations_h
#define _PBCSequations_h

// adds the equation l1 = l2 and updates all datastructures
int equate(int l1, int l2);

// checks whether there are some equations deducible
// by fixing single literals and then checking their implications.
// also aplies these detected equations
int eq_check(); // returns the number of generated equations

// private use: replaces left by right and -left by -right.
// in fact left = right holds and 
// left is the canonical representation of the literal right.
int replace_lit(int left, int right);
int replace_lit_ref(RArray<LitRef> ref, int left, int right);

#endif

