#include "PolPBIneq.h"


PolPBIneq::PolPBIneq() : rhs(0)
{
}

PolPBIneq::PolPBIneq(PolPBIneq& i) : t(i.t) , rhs(i.rhs)
{
}

PolPBIneq::PolPBIneq(PolPBTerm& pbt, Coefficient r)
{
  t = pbt;
  rhs = r-t.constant;
  t.constant = 0;
}

PolPBIneq& PolPBIneq::operator=(PolPBIneq& i)
{
  t = i.t;
  rhs = i.rhs;
  return *this;
}

PolPBIneq::~PolPBIneq()
{
  // nothing to do
}

int PolPBIneq::Print(ostream& out, Atoms* atoms)
{
  t.Print(out,atoms);
  out << " >= " << rhs;
  return 0;
}

int PolPBIneq::normalize()
{
  if (t.constant != 0)
    {
      rhs -= t.constant;
      t.constant = 0;
    }
  return 0;
}
